WeaponWarn = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceEvent-2.0")
local self = WeaponWarn

WeaponWarn:RegisterDB("WeaponWarnDB")

function WeaponWarn:OnInitialize()
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("EQUIPMENT_SWAP_FINISHED")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
end

SLASH_WEAPONWARN1 = "/ww";
local function handler(msg, editbox)
 if msg and not (msg=="none" or msg=="off" or msg=="on" or msg=="help" or msg=="autoon" or msg=="autooff" or msg=="")then 
		self.db.char.name = msg
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponWarn:|r Current set |cff00ff00 %s|r", msg ))
	end
	if (msg=="none") then
		self.db.char.name = nil
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r Current set |cffff0000 None|r")
	end
	if (msg=="off") then
		self.db.char.enable = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r |cffff0000Off|r")
	end
	if (msg=="on") then
		self.db.char.enable = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r |cff00ff00On|r")
	end
	if (msg=="autoon") then
		self.db.char.auto = true
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r |cff00ff00AutoOn|r")
	end
	if (msg=="autooff") then
		self.db.char.auto = false
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r |cffff0000AutoOff|r")
	end
	if (msg=="help" or msg=="") then
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To manually specify an equipment set type /ww and the exact name of the set you want to use.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To not use an equipment set and display only a warning type /ww none.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To automatically select the last set with usable weapons type /ww autoon or to disable type /ww autooff.")
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r To enable or disable type /ww on or /ww off.")
	end
end
SlashCmdList["WEAPONWARN"] = handler;


function WeaponWarn:ADDON_LOADED(event, addon)
	if addon == "WeaponWarn" then
		WeaponWarnDB = WeaponWarnDB
		self:SetScript( "OnUpdate", handler)
	end
end

		
function WeaponWarn:PLAYER_REGEN_DISABLED()
	if (self.db.char.enable == false) then 
	return;
	else
		if (self.db.char.name == nil) and IsEquippedItemType("Fishing Poles") then
			RaidNotice_AddMessage( RaidBossEmoteFrame, "Fishing Pole equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
			PlaySound("RaidBossEmoteWarning")
		end
		if self.db.char.name and IsEquippedItemType("Fishing Poles") then
			local ok = UseEquipmentSet(self.db.char.name)
			if ok then
				UseEquipmentSet(self.db.char.name)
			else
				RaidNotice_AddMessage( RaidBossEmoteFrame, "Fishing Pole equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r Invalid equipment set name. Could not equip.")
				PlaySound("RaidBossEmoteWarning")
			end
		end
		
		if (self.db.char.name == nil) and (IsEquippedItem("Argent Lance") or IsEquippedItem("Alliance Lance") or IsEquippedItem("Horde Lance")) and not UnitInVehicle("player") then
			RaidNotice_AddMessage( RaidBossEmoteFrame, "Jousting Lance equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
			PlaySound("RaidBossEmoteWarning")
		end
		if self.db.char.name and (IsEquippedItem("Argent Lance") or IsEquippedItem("Alliance Lance") or IsEquippedItem("Horde Lance")) and not UnitInVehicle("player")then
			local ok = UseEquipmentSet(self.db.char.name)
			if ok then
				UseEquipmentSet(self.db.char.name)
			else
				RaidNotice_AddMessage( RaidBossEmoteFrame, "Jousting Lance equipped! Equip a weapon.", ChatTypeInfo["RAID_BOSS_EMOTE"] );
				DEFAULT_CHAT_FRAME:AddMessage("|cffffff00WeaponWarn:|r Invalid equipment set name. Could not equip.")
				PlaySound("RaidBossEmoteWarning")
			end
		end
	end
end

function WeaponWarn:COMBAT_LOG_EVENT_UNFILTERED(...)
	if (self.db.char.enable == false) then 
	return;
	else
	local sourceGUID = select(3, ...)
	local type = select(2, ...)
	local playerGUID = UnitGUID("player")			
		if (sourceGUID==playerGUID) and UnitAffectingCombat("player")then
			if (type == "SWING_DAMAGE" or type == "RANGE_DAMAGE" or type == "SPELL_DAMAGE" or type == "SPELL_HEAL") then
				if self.db.char.name and (IsEquippedItem("Argent Lance") or IsEquippedItem("Alliance Lance") or IsEquippedItem("Horde Lance")) and not UnitInVehicle("player")then
					UseEquipmentSet(self.db.char.name)
				end
				if self.db.char.name and IsEquippedItemType("Fishing Poles") then
					UseEquipmentSet(self.db.char.name)
				end
			end
		end
	end
end	

function WeaponWarn:CheckSet()
local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo("MainHandSlot"))
local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(mainHandLink)
	if not (self.db.char.name == nil) and not UnitAffectingCombat("player") and not (IsEquippedItemType("Fishing Poles") or IsEquippedItem("Argent Lance") or IsEquippedItem("Alliance Lance") or IsEquippedItem("Horde Lance")) and itemRarity > 1 then
		self.db.char.name = self.db.char.lastset
	end
end

function WeaponWarn:UNIT_INVENTORY_CHANGED(unit)
	if (unit ~= "player") or (self.db.char.enable == false) then
		return;
	end
	if (self.db.char.auto == true) then
		WeaponWarn:CheckSet();
	end
end

function WeaponWarn:EQUIPMENT_SWAP_FINISHED(ok, name)
	if (self.db.char.enable == false) then 
	return;
	else
	if (ok == true) and UnitAffectingCombat("player") and self.db.char.name and not UnitInVehicle("player") then
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00WeaponWarn:|r Switched to weapons from set |cff00ff00 %s|r", name ))
	end
	end
		self.db.char.lastset = name
end


